searchNodes=[{"ref":"ExMachina.html","title":"ExMachina","type":"behaviour","doc":"Defines functions for generating data In depth examples are in the README"},{"ref":"ExMachina.html#c:build/1","title":"ExMachina.build/1","type":"callback","doc":"Builds a single factory. This will defer to the [factory_name]_factory/0 callback defined in the factory module in which it is used. Example def user_factory do %{name: &quot;John Doe&quot;, admin: false} end # Returns %{name: &quot;John Doe&quot;, admin: false} build(:user) # Returns %{name: &quot;John Doe&quot;, admin: true} build(:user, admin: true) Full control of a factory&#39;s attributes If you want full control over the factory attributes, you can define the factory with [factory_name]_factory/1, taking in the attributes as the first argument. Caveats: ExMachina will no longer merge the attributes for your factory. If you want to do that, you can merge the attributes with the merge_attributes/2 helper. ExMachina will no longer evaluate lazy attributes. If you want to do that, you can evaluate the lazy attributes with the evaluate_lazy_attributes/1 helper. Example def article_factory(attrs) do title = Map.get(attrs, :title, &quot;default title&quot;) slug = Article.title_to_slug(title) article = %Article{title: title, slug: slug} article # merge attributes on your own |&gt; merge_attributes(attrs) # evaluate any lazy attributes |&gt; evaluate_lazy_attributes() end # Returns %Article{title: &quot;default title&quot;, slug: &quot;default-title&quot;} build(:article) # Returns %Article{title: &quot;hello world&quot;, slug: &quot;hello-world&quot;} build(:article, title: &quot;hello world&quot;)"},{"ref":"ExMachina.html#c:build/2","title":"ExMachina.build/2","type":"callback","doc":""},{"ref":"ExMachina.html#c:build_list/2","title":"ExMachina.build_list/2","type":"callback","doc":"Builds any number of factories. Example # Returns a list of 3 users build_list(3, :user)"},{"ref":"ExMachina.html#c:build_list/3","title":"ExMachina.build_list/3","type":"callback","doc":""},{"ref":"ExMachina.html#c:build_pair/1","title":"ExMachina.build_pair/1","type":"callback","doc":"Builds two factories. This is just an alias for build_list(2, factory_name, attrs). Example # Returns a list of 2 users build_pair(:user)"},{"ref":"ExMachina.html#c:build_pair/2","title":"ExMachina.build_pair/2","type":"callback","doc":""},{"ref":"ExMachina.html#evaluate_lazy_attributes/1","title":"ExMachina.evaluate_lazy_attributes/1","type":"function","doc":"Helper function to evaluate lazy attributes that are passed into a factory. Example # custom factory def article_factory(attrs) do %{title: &quot;title&quot;} |&gt; merge_attributes(attrs) |&gt; evaluate_lazy_attributes() end def author_factory do %{name: sequence(&quot;gandalf&quot;)} end # =&gt; returns [ # %{title: &quot;title&quot;, author: %{name: &quot;gandalf0&quot;}, # %{title: &quot;title&quot;, author: %{name: &quot;gandalf0&quot;} # ] build_pair(:article, author: build(:author)) # =&gt; returns [ # %{title: &quot;title&quot;, author: %{name: &quot;gandalf0&quot;}, # %{title: &quot;title&quot;, author: %{name: &quot;gandalf1&quot;} # ] build_pair(:article, author: fn -&gt; build(:author) end)"},{"ref":"ExMachina.html#merge_attributes/2","title":"ExMachina.merge_attributes/2","type":"function","doc":"Helper function to merge attributes into a factory that could be either a map or a struct. Example # custom factory def article_factory(attrs) do title = Map.get(attrs, :title, &quot;default title&quot;) article = %Article{ title: title } merge_attributes(article, attrs) end Note that when trying to merge attributes into a struct, this function will raise if one of the attributes is not defined in the struct."},{"ref":"ExMachina.html#sequence/1","title":"ExMachina.sequence/1","type":"function","doc":"Shortcut for creating unique string values. This is automatically imported into a model factory when you use ExMachina. This is equivalent to sequence(name, &amp;&quot;\#{name}\#{&amp;1}&quot;). If you need to customize the returned string, see sequence/2. Note that sequences keep growing and are not reset by ExMachina. Most of the time you won&#39;t need to reset the sequence, but when you do need to reset them, you can use ExMachina.Sequence.reset/0. Examples def user_factory do %User{ # Will generate &quot;username0&quot; then &quot;username1&quot;, etc. username: sequence(&quot;username&quot;) } end def article_factory do %Article{ # Will generate &quot;Article Title0&quot; then &quot;Article Title1&quot;, etc. title: sequence(&quot;Article Title&quot;) } end"},{"ref":"ExMachina.html#sequence/2","title":"ExMachina.sequence/2","type":"function","doc":"Create sequences for generating unique values. This is automatically imported into a model factory when you use ExMachina. The name can be any term, although it is typically an atom describing the sequence. Each time a sequence is called with the same name, its number is incremented by one. The formatter function takes the sequence number, and returns a sequential representation of that number – typically a formatted string. Examples def user_factory do %{ # Will generate &quot;me-0@foo.com&quot; then &quot;me-1@foo.com&quot;, etc. email: sequence(:email, &amp;&quot;me-\#{&amp;1}@foo.com&quot;), # Will generate &quot;admin&quot; then &quot;user&quot;, &quot;other&quot;, &quot;admin&quot; etc. role: sequence(:role, [&quot;admin&quot;, &quot;user&quot;, &quot;other&quot;]) } end"},{"ref":"ExMachina.Ecto.html","title":"ExMachina.Ecto","type":"behaviour","doc":"Module for building and inserting factories with Ecto This module works much like the regular ExMachina module, but adds a few nice things that make working with Ecto easier. It uses ExMachina.EctoStrategy, which adds insert/1, insert/2, insert_pair/2, insert_list/3. Adds a params_for function that is useful for working with changesets or sending params to API endpoints. More in-depth examples are in the README."},{"ref":"ExMachina.Ecto.html#c:insert/1","title":"ExMachina.Ecto.insert/1","type":"callback","doc":"Builds a factory and inserts it into the database. The arguments are the same as ExMachina.build/2."},{"ref":"ExMachina.Ecto.html#c:insert/2","title":"ExMachina.Ecto.insert/2","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:insert_list/2","title":"ExMachina.Ecto.insert_list/2","type":"callback","doc":"Builds many factories and inserts them into the database. The arguments are the same as ExMachina.build_list/3."},{"ref":"ExMachina.Ecto.html#c:insert_list/3","title":"ExMachina.Ecto.insert_list/3","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:insert_pair/1","title":"ExMachina.Ecto.insert_pair/1","type":"callback","doc":"Builds two factories and inserts them into the database. The arguments are the same as ExMachina.build_pair/2."},{"ref":"ExMachina.Ecto.html#c:insert_pair/2","title":"ExMachina.Ecto.insert_pair/2","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:params_for/1","title":"ExMachina.Ecto.params_for/1","type":"callback","doc":"Builds a factory and returns only its fields. This is only for use with Ecto models. Will return a map with the fields and virtual fields, but without the Ecto metadata, the primary key, or any belongs_to associations. This will recursively act on has_one associations and Ecto structs found in has_many associations. If you want belongs_to associations to be inserted, use params_with_assocs/2. If you want params with string keys use string_params_for/2. Example def user_factory do %MyApp.User{name: &quot;John Doe&quot;, admin: false} end # Returns %{name: &quot;John Doe&quot;, admin: true} params_for(:user, admin: true) # Returns %{name: &quot;John Doe&quot;, admin: false} params_for(:user)"},{"ref":"ExMachina.Ecto.html#c:params_for/2","title":"ExMachina.Ecto.params_for/2","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:params_with_assocs/1","title":"ExMachina.Ecto.params_with_assocs/1","type":"callback","doc":"Similar to params_for/2 but inserts all belongs_to associations and sets the foreign keys. If you want params with string keys use string_params_with_assocs/2. Example def article_factory do %MyApp.Article{title: &quot;An Awesome Article&quot;, author: build(:author)} end # Inserts an author and returns %{title: &quot;An Awesome Article&quot;, author_id: 12} params_with_assocs(:article)"},{"ref":"ExMachina.Ecto.html#c:params_with_assocs/2","title":"ExMachina.Ecto.params_with_assocs/2","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:string_params_for/1","title":"ExMachina.Ecto.string_params_for/1","type":"callback","doc":"Similar to params_for/2 but converts atom keys to strings in returned map. The result of this function can be safely used in controller tests for Phoenix web applications. Example def user_factory do %MyApp.User{name: &quot;John Doe&quot;, admin: false} end # Returns %{&quot;name&quot; =&gt; &quot;John Doe&quot;, &quot;admin&quot; =&gt; true} string_params_for(:user, admin: true)"},{"ref":"ExMachina.Ecto.html#c:string_params_for/2","title":"ExMachina.Ecto.string_params_for/2","type":"callback","doc":""},{"ref":"ExMachina.Ecto.html#c:string_params_with_assocs/1","title":"ExMachina.Ecto.string_params_with_assocs/1","type":"callback","doc":"Similar to params_with_assocs/2 but converts atom keys to strings in returned map. The result of this function can be safely used in controller tests for Phoenix web applications. Example def article_factory do %MyApp.Article{title: &quot;An Awesome Article&quot;, author: build(:author)} end # Inserts an author and returns %{&quot;title&quot; =&gt; &quot;An Awesome Article&quot;, &quot;author_id&quot; =&gt; 12} string_params_with_assocs(:article)"},{"ref":"ExMachina.Ecto.html#c:string_params_with_assocs/2","title":"ExMachina.Ecto.string_params_with_assocs/2","type":"callback","doc":""},{"ref":"ExMachina.Sequence.html","title":"ExMachina.Sequence","type":"module","doc":"Module for generating sequential values. Use ExMachina.sequence/1 or ExMachina.sequence/2 to generate sequential values instead of calling this module directly."},{"ref":"ExMachina.Sequence.html#reset/0","title":"ExMachina.Sequence.reset/0","type":"function","doc":"Reset all sequences so that the next sequence starts from 0 Example ExMachina.Sequence.next(&quot;joe&quot;) # &quot;joe0&quot; ExMachina.Sequence.next(&quot;joe&quot;) # &quot;joe1&quot; ExMachina.Sequence.reset() ExMachina.Sequence.next(&quot;joe&quot;) # resets so the return value is &quot;joe0&quot; You can use list as well ExMachina.Sequence.next(&quot;alphabet_sequence&quot;, [&quot;A&quot;, &quot;B&quot;]) # &quot;A&quot; ExMachina.Sequence.next(&quot;alphabet_sequence&quot;, [&quot;A&quot;, &quot;B&quot;]) # &quot;B&quot; ExMachina.Sequence.reset() ExMachina.Sequence.next(&quot;alphabet_sequence&quot;[&quot;A&quot;, &quot;B&quot;]) # resets so the return value is &quot;A&quot; If you want to reset sequences at the beginning of every test, put it in a setup block in your test. setup do ExMachina.Sequence.reset() end"},{"ref":"ExMachina.Sequence.html#reset/1","title":"ExMachina.Sequence.reset/1","type":"function","doc":"Reset specific sequences so long as they already exist. The sequences specified will be reset to 0, while others will remain at their current index. You can reset a single sequence, Example ExMachina.Sequence.next(:alphabet, [&quot;A&quot;, &quot;B&quot;, &quot;C&quot;]) # &quot;A&quot; ExMachina.Sequence.next(:alphabet, [&quot;A&quot;, &quot;B&quot;, &quot;C&quot;]) # &quot;B&quot; ExMachina.Sequence.reset(:alphabet) ExMachina.Sequence.next(:alphabet, [&quot;A&quot;, &quot;B&quot;, &quot;C&quot;]) # &quot;A&quot; And you can also reset multiple sequences at once, Example ExMachina.Sequence.next(:numeric, [1, 2, 3]) # 1 ExMachina.Sequence.next(:numeric, [1, 2, 3]) # 2 ExMachina.Sequence.next(&quot;joe&quot;) # &quot;joe0&quot; ExMachina.Sequence.next(&quot;joe&quot;) # &quot;joe1&quot; ExMachina.Sequence.reset([&quot;joe&quot;, :numeric]) ExMachina.Sequence.next(:numeric, [1, 2, 3]) # 1 ExMachina.Sequence.next(&quot;joe&quot;) # &quot;joe0&quot;"},{"ref":"ExMachina.Strategy.html","title":"ExMachina.Strategy","type":"module","doc":"Module for making new strategies for working with factories Example defmodule MyApp.JsonEncodeStrategy do # The function_name will be used to generate functions in your factory # This example adds json_encode/1, json_encode/2, json_encode_pair/2 and json_encode_list/3 use ExMachina.Strategy, function_name: :json_encode # Define a function for handling the records. # Takes the form of &quot;handle_\#{function_name}&quot; def handle_json_encode(record, _opts) do Poison.encode!(record) end end defmodule MyApp.JsonFactory do use ExMachina use MyApp.JsonEncodeStrategy def user_factory do %User{name: &quot;John&quot;} end end # Will build and then return a JSON encoded version of the user. MyApp.JsonFactories.json_encode(:user) The arguments sent to the handling function are 1) The built record 2) The options passed to the strategy The options sent as the second argument are always converted to a map. The options are anything you passed when you use your strategy in your factory, merged together with %{factory_module: FactoryItWasCalledFrom}. This allows for customizing the strategy, and for calling other functions on the factory if needed. See ExMachina.EctoStrategy in the ExMachina repo, and the docs for name_from_struct/1 for more examples."},{"ref":"ExMachina.Strategy.html#name_from_struct/1","title":"ExMachina.Strategy.name_from_struct/1","type":"function","doc":"Returns the factory name from a struct. Useful for strategies with callbacks. This function can be useful when you want to call other functions based on the type of struct passed in. For example, if you wanted to call a function on the factory module before JSON encoding. Examples ExMachina.Strategy.name_from_struct(%User{}) # Returns :user ExMachina.Strategy.name_from_struct(%MyUser{}) # Returns :my_user ExMachina.Strategy.name_from_struct(%MyApp.MyTask{}) # Returns :my_task Implementing callback functions with name_from_struct/1 defmodule MyApp.JsonEncodeStrategy do use ExMachina.Strategy, function_name: :json_encode def handle_json_encode(record, %{factory_module: factory_module}) do # If the record was a %User{} this would return :before_encode_user callback_func_name = :&quot;before_encode_\#{ExMachina.Strategy.name_from_struct(record)}&quot; if callback_defined?(factory_module, callback_func_name) do # First call the callback function apply(factory_module, callback_func_name, [record]) # Then encode it |&gt; Poison.encode! else # Otherwise, encode it without calling any callback Poison.encode!(record) end end defp callback_defined?(module, func_name) do Code.ensure_loaded?(module) &amp;&amp; function_exported?(module, func_name, 1) end end"},{"ref":"ExMachina.UndefinedFactoryError.html","title":"ExMachina.UndefinedFactoryError","type":"exception","doc":"Error raised when trying to build or create a factory that is undefined."},{"ref":"readme.html","title":"ExMachina","type":"extras","doc":"ExMachina ExMachina is part of the thoughtbot Elixir family of projects. ExMachina makes it easy to create test data and associations. It works great with Ecto, but is configurable to work with any persistence library. This README follows master, which may not be the currently published version. Here are the docs for the latest published version of ExMachina."},{"ref":"readme.html#installation","title":"ExMachina - Installation","type":"extras","doc":"To install in all environments (useful for generating seed data in dev/prod): In mix.exs, add the ExMachina dependency: def deps do # Get the latest from hex.pm. Works with Ecto 3.0 [ {:ex_machina, &quot;~&gt; 2.5.0&quot;}, ] end And start the ExMachina application. For most projects (such as Phoenix apps) this will mean adding :ex_machina to the list of applications in mix.exs. You can skip this step if you are using Elixir 1.4 or later. def application do [mod: {MyApp, []}, applications: [:ex_machina, :other_apps...]] end Install in just the test environment with Phoenix: In mix.exs, add the ExMachina dependency: def deps do [ {:ex_machina, &quot;~&gt; 2.4&quot;, only: :test}, ] end Add your factory module inside test/support so that it is only compiled in the test environment. Next, be sure to start the application in your test/test_helper.exs before ExUnit.start: {:ok, _} = Application.ensure_all_started(:ex_machina) Install in just the test environment for non-Phoenix projects: You will follow the same instructions as above, but you will also need to add test/support to your compilation paths (elixirc_paths) if you have not done so already. In mix.exs, add test/support to your elixirc_paths for just the test env. def project do [app: ..., # Add this if it&#39;s not already in your project definition. elixirc_paths: elixirc_paths(Mix.env)] end # This makes sure your factory and any other modules in test/support are compiled # when in the test environment. defp elixirc_paths(:test), do: [&quot;lib&quot;, &quot;web&quot;, &quot;test/support&quot;] defp elixirc_paths(_), do: [&quot;lib&quot;, &quot;web&quot;]"},{"ref":"readme.html#overview","title":"ExMachina - Overview","type":"extras","doc":"Check out the docs for more details. Define factories: defmodule MyApp.Factory do # with Ecto use ExMachina.Ecto, repo: MyApp.Repo # without Ecto use ExMachina def user_factory do %MyApp.User{ name: &quot;Jane Smith&quot;, email: sequence(:email, &amp;&quot;email-\#{&amp;1}@example.com&quot;), role: sequence(:role, [&quot;admin&quot;, &quot;user&quot;, &quot;other&quot;]), } end def article_factory do title = sequence(:title, &amp;&quot;Use ExMachina! (Part \#{&amp;1})&quot;) # derived attribute slug = MyApp.Article.title_to_slug(title) %MyApp.Article{ title: title, slug: slug, # associations are inserted when you call `insert` author: build(:user), } end # derived factory def featured_article_factory do struct!( article_factory(), %{ featured: true, } ) end def comment_factory do %MyApp.Comment{ text: &quot;It&#39;s great!&quot;, article: build(:article), } end end Using factories (check out the docs for more details): # `attrs` are automatically merged in for all build/insert functions. # `build*` returns an unsaved comment. # Associated records defined on the factory are built. attrs = %{body: &quot;A comment!&quot;} # attrs is optional. Also accepts a keyword list. build(:comment, attrs) build_pair(:comment, attrs) build_list(3, :comment, attrs) # `insert*` returns an inserted comment. Only works with ExMachina.Ecto # Associated records defined on the factory are inserted as well. insert(:comment, attrs) insert_pair(:comment, attrs) insert_list(3, :comment, attrs) # `params_for` returns a plain map without any Ecto specific attributes. # This is only available when using [`ExMachina.Ecto`](ExMachina.Ecto.html). params_for(:comment, attrs) # `params_with_assocs` is the same as `params_for` but inserts all belongs_to # associations and sets the foreign keys. # This is only available when using [`ExMachina.Ecto`](ExMachina.Ecto.html). params_with_assocs(:comment, attrs) # Use `string_params_for` to generate maps with string keys. This can be useful # for Phoenix controller tests. string_params_for(:comment, attrs) string_params_with_assocs(:comment, attrs)"},{"ref":"readme.html#delayed-evaluation-of-attributes","title":"ExMachina - Delayed evaluation of attributes","type":"extras","doc":"build/2 is a function call. As such, it gets evaluated immediately. So this code: insert_pair(:account, user: build(:user)) Is equivalent to this: user = build(:user) insert_pair(:account, user: user) # same user for both accounts Sometimes that presents a problem. Consider the following factory: def user_factory do %{name: &quot;Gandalf&quot;, email: sequence(:email, &quot;gandalf\#{&amp;1}@istari.com&quot;)} end If you want to build a separate user per account, then calling insert_pair(:account, user: build(:user)) will not give you the desired result. In those cases, you can delay the execution of the factory by passing it as an anonymous function: insert_pair(:account, user: fn -&gt; build(:user) end) You can also do that in a factory definition: def account_factory do %{user: fn -&gt; build(:user) end} end You can even accept the parent record as an argument to the function: def account_factory do %{user: fn account -&gt; build(:user, vip: account.premium) end} end"},{"ref":"readme.html#full-control-of-factory","title":"ExMachina - Full control of factory","type":"extras","doc":"By default, ExMachina will merge the attributes you pass into build/insert into your factory. But if you want full control of your attributes, you can define your factory as accepting one argument, the attributes being passed into your factory. def custom_article_factory(attrs) do title = Map.get(attrs, :title, &quot;default title&quot;) article = %Article{ author: &quot;John Doe&quot;, title: title } # merge attributes and evaluate lazy attributes at the end to emulate # ExMachina&#39;s default behavior article |&gt; merge_attributes(attrs) |&gt; evaluate_lazy_attributes() end NOTE that in this case ExMachina will not merge the attributes into your factory, and it will not evaluate lazy attributes. You will have to do this on your own if desired. Non-map factories Because you have full control of the factory when defining it with one argument, you can build factories that are neither maps nor structs. # factory definition def room_number_factory(attrs) do %{floor: floor_number} = attrs sequence(:room_number, &amp;&quot;\#{floor_number}0\#{&amp;1}&quot;) end # example usage build(:room_number, floor: 5) # =&gt; &quot;500&quot; build(:room_number, floor: 5) # =&gt; &quot;501&quot; NOTE that you cannot use non-map factories with Ecto. So you cannot insert(:room_number)."},{"ref":"readme.html#usage-in-a-test","title":"ExMachina - Usage in a test","type":"extras","doc":"# Example of use in Phoenix with a factory that uses ExMachina.Ecto defmodule MyApp.MyModuleTest do use MyApp.ConnCase # If using Phoenix, import this inside the using block in MyApp.ConnCase import MyApp.Factory test &quot;shows comments for an article&quot; do conn = conn() article = insert(:article) comment = insert(:comment, article: article) conn = get conn, article_path(conn, :show, article.id) assert html_response(conn, 200) =~ article.title assert html_response(conn, 200) =~ comment.body end end"},{"ref":"readme.html#where-to-put-your-factories","title":"ExMachina - Where to put your factories","type":"extras","doc":"If you are using ExMachina in all environments: Start by creating one factory module (such as MyApp.Factory) in lib/my_app/factory.ex and putting all factory definitions in that module. If you are using ExMachina in only the test environment: Start by creating one factory module (such as MyApp.Factory) in test/support/factory.ex and putting all factory definitions in that module. Later on you can easily create different factories by creating a new module in the same directory. This can be helpful if you need to create factories that are used for different repos, your factory module is getting too big, or if you have different ways of saving the record for different types of factories. Splitting factories into separate files This example shows how to set up factories for the testing environment. For setting them in all environments, please see the To install in all environments section Start by creating main factory module in test/support/factory.ex and name it MyApp.Factory. The purpose of the main factory is to allow you to include only a single module in all tests. # test/support/factory.ex defmodule MyApp.Factory do use ExMachina.Ecto, repo: MyApp.Repo use MyApp.ArticleFactory end The main factory includes MyApp.ArticleFactory, so let&#39;s create it next. It might be useful to create a separate directory for factories, like test/factories. Here is how to create a factory: # test/factories/article_factory.ex defmodule MyApp.ArticleFactory do defmacro __using__(_opts) do quote do def article_factory do %MyApp.Article{ title: &quot;My awesome article!&quot;, body: &quot;Still working on it!&quot; } end end end end This way you can split your giant factory file into many small files. But what about name conflicts? Use pattern matching to avoid them! # test/factories/post_factory.ex defmodule MyApp.PostFactory do defmacro __using__(_opts) do quote do def post_factory do %MyApp.Post{ body: &quot;Example body&quot; } end def with_comments(%MyApp.Post{} = post) do insert_pair(:comment, post: post) post end end end end # test/factories/video_factory.ex defmodule MyApp.VideoFactory do defmacro __using__(_opts) do quote do def video_factory do %MyApp.Video{ url: &quot;example_url&quot; } end def with_comments(%MyApp.Video{} = video) do insert_pair(:comment, video: video) video end end end end"},{"ref":"readme.html#ecto-associations","title":"ExMachina - Ecto Associations","type":"extras","doc":"ExMachina will automatically save any associations when you call any of the insert functions. This includes belongs_to and anything that is inserted by Ecto when using Repo.insert!, such as has_many, has_one, and embeds. Since we automatically save these records for you, we advise that factory definitions only use build/2 when declaring associations, like so: def article_factory do %Article{ title: &quot;Use ExMachina!&quot;, # associations are inserted when you call `insert` comments: [build(:comment)], author: build(:user), } end Using insert/2 in factory definitions may lead to performance issues and bugs, as records will be saved unnecessarily."},{"ref":"readme.html#flexible-factories-with-pipes","title":"ExMachina - Flexible Factories with Pipes","type":"extras","doc":"def make_admin(user) do %{user | admin: true} end def with_article(user) do insert(:article, user: user) user end build(:user) |&gt; make_admin |&gt; insert |&gt; with_article"},{"ref":"readme.html#using-with-phoenix","title":"ExMachina - Using with Phoenix","type":"extras","doc":"If you want to keep the factories somewhere other than test/support, change this line in mix.exs: # Add the folder to the end of the list. In this case we&#39;re adding `test/factories`. defp elixirc_paths(:test), do: [&quot;lib&quot;, &quot;web&quot;, &quot;test/support&quot;, &quot;test/factories&quot;]"},{"ref":"readme.html#custom-strategies","title":"ExMachina - Custom Strategies","type":"extras","doc":"You can use ExMachina without Ecto, by using just the build functions, or you can define one or more custom strategies to use in your factory. You can also use custom strategies with Ecto. Here&#39;s an example of a strategy for json encoding your factories. See the docs on ExMachina.Strategy for more info. defmodule MyApp.JsonEncodeStrategy do use ExMachina.Strategy, function_name: :json_encode def handle_json_encode(record, _opts) do Poison.encode!(record) end end defmodule MyApp.Factory do use ExMachina # Using this will add json_encode/2, json_encode_pair/2 and json_encode_list/3 use MyApp.JsonEncodeStrategy def user_factory do %User{name: &quot;John&quot;} end end # Will build and then return a JSON encoded version of the user. MyApp.Factory.json_encode(:user)"},{"ref":"readme.html#contributing","title":"ExMachina - Contributing","type":"extras","doc":"Before opening a pull request, please open an issue first. $ git clone https://github.com/thoughtbot/ex_machina.git $ cd ex_machina $ mix deps.get $ mix test Once you&#39;ve made your additions and mix test passes, go ahead and open a PR!"},{"ref":"readme.html#license","title":"ExMachina - License","type":"extras","doc":"ExMachina is Copyright © 2015 thoughtbot. It is free software, and may be redistributed under the terms specified in the LICENSE file."},{"ref":"readme.html#about-thoughtbot","title":"ExMachina - About thoughtbot","type":"extras","doc":"ExMachina is maintained and funded by thoughtbot, inc. The names and logos for thoughtbot are trademarks of thoughtbot, inc. We love open source software, Elixir, and Phoenix. See our other Elixir projects, or hire our Elixir Phoenix development team to design, develop, and grow your product."},{"ref":"readme.html#inspiration","title":"ExMachina - Inspiration","type":"extras","doc":"Fixtures for Ecto Factory Bot"}]